#pragma once

template < class T >
class ATL_NO_VTABLE IClientAddInImpl :
	public IClientAddIn
{
public:
  BEGIN_COM_MAP(IClientAddInImpl < T > )
    COM_INTERFACE_ENTRY(IClientAddIn)
  END_COM_MAP()

// IClientAddIn implementation
public:
	STDMETHOD (GetAbout) (/*out*/ BSTR* pbstrAbout,
		                  /*out*/ BSTR* pbstrInfo)
	{
		if (NULL != pbstrAbout)
			*pbstrAbout = m_bstrAbout.Copy();

		if (NULL != pbstrInfo)
			*pbstrInfo = m_bstrInfo.Copy();

		return NOERROR;
	}

	STDMETHOD (OnLoad) (/*in*/ IDispatch* pClientApplication)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (OnUnload) ()
	{
		return E_NOTIMPL;
	}

	CComBSTR m_bstrAbout;
	CComBSTR m_bstrInfo;
};
