#pragma once

template < class T, const GUID* plibid = &CAtlModule::m_libid, WORD wMajor = 1, WORD wMinor = 0 >
class ATL_NO_VTABLE ICmdHookHandlerImpl :
	public IDispatchImpl < ICmdHook, &__uuidof(ICmdHook), plibid, wMajor, wMinor >
{
public:
  BEGIN_COM_MAP(ICmdHookHandlerImpl < T > )
    COM_INTERFACE_ENTRY(ICmdHook)
    COM_INTERFACE_ENTRY2(IDispatch, ICmdHook)
  END_COM_MAP()

// ICmdHook implementation
public:
	STDMETHOD (IsHandled) (
		/*in*/          IDispatch* pObject,
		/*in*/          LONG       lCmdID,
		/*out, retval*/ BOOL*      pbRetC)
	{
		if (NULL == pbRetC)
			return E_POINTER;

		return E_NOTIMPL;
	}

	STDMETHOD (Execute) (
		/*in*/          IDispatch* pObject,
		/*in*/          LONG       lCmdID,
        /*out, retval*/ BOOL*      pbRetC)
	{
		if (NULL == pbRetC)
			return E_POINTER;

		return E_NOTIMPL;
	}
};
