Set oMessenger = WScript.CreateObject("ECtiClient.Messenger") ' direct address our implementation without Office MessengerBinding

' MyStatus property is implemented by ECtiClient
' but Deprecated in Windows Messenger 5.0
' oMessenger.MyStatus = 2 ' MISTATUS_ONLINE
' oMessenger.MyStatus = 10 ' MISTATUS_BUSY

strSipUri = oMessenger.MySigninName ' oMessenger.Services.PrimaryService.MySigninName
WScript.Echo "SipUri: " & strSipUri
strServiceID = oMessenger.Services.PrimaryService.ServiceID
WScript.Echo "ServiceID: " & strServiceID

Set oMeContact = oMessenger.GetContact(strSipUri, strServiceID)
WScript.Echo "FriendlyName: " & oMeContact.FriendlyName

' create array with four elements
' NOTE:
'   put_PresenceProperties requires an array
'   VBS does not support one sized arrays, Dim saXYZ(0) is wrong syntax
'   to change ONLY PRESENCE_PROP_MSTATE you have to provide an array with at least two elements.
'   keep the second one of type VT_EMPTY
Dim saPresenceProperties(3) '                                                ECtiClient    Communicator   Messenger
saPresenceProperties(0) = 10  ' PRESENCE_PROP_MSTATE = 0x00                    Yes          unknown       unknown

' if you skip initialization of a member it will be of type VT_EMPTY. VT_EMPTY elements are ignored by IMessengerContactAdvanced::put_PresenceProperties()
' saPresenceProperties(1) = 0   ' PRESENCE_PROP_AVAILABILITY = 0x1,             No           unknown       unknown
' saPresenceProperties(2) = False ' PRESENCE_PROP_IS_BLOCKED = 0x2,            Yes          unknown       unknown

' PRESENCE_PROP_PRESENCE_NOTE = 0x3,                                            No          unknown       unknown
saPresenceProperties(3) = "changed via API"

' saPresenceProperties(4) = "" ' PRESENCE_PROP_IS_OOF = 0x4,                    No          unknown       unknown
' saPresenceProperties(5) = "" ' PRESENCE_PROP_TOOL_TIP = 0x5,                  No          unknown       unknown
' saPresenceProperties(6) = "" ' PRESENCE_PROP_CUSTOM_STATUS_STRING = 0x6,      No          unknown       unknown

' keep in mind: Communicator 2007 does not support scripting for this property
'   http://msdn.microsoft.com/en-us/library/bb758717(office.12).aspx
oMeContact.PresenceProperties = saPresenceProperties

WScript.Echo "Finished"