using System;
using System.Windows.Forms;

namespace CSNetTSC
{
	/// <summary>
	/// Zusammenfassung fr LineTreeNode.
	/// </summary>
	public class LineTreeNode : TreeNode
	{
        private ENETTSCLib.Line thisLine;
        private string thisLineName;

        public LineTreeNode(ENETTSCLib.Line line) : base()
        {
            thisLineName = String.Format("[L{0:X8}]: Line {1}", line.ID, line.Number);
            thisLine = line;
            Text = thisLineName;
        }

        public ENETTSCLib.Line getLine() 
        {
            return thisLine;
        }
	}
}
