VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6885
   ClientLeft      =   3120
   ClientTop       =   3330
   ClientWidth     =   10125
   LinkTopic       =   "Form1"
   ScaleHeight     =   6885
   ScaleWidth      =   10125
   StartUpPosition =   2  'Bildschirmmitte
   Begin MSComctlLib.TreeView LCTree 
      Height          =   6495
      Left            =   4560
      TabIndex        =   3
      Top             =   240
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   11456
      _Version        =   393217
      HideSelection   =   0   'False
      Indentation     =   529
      LineStyle       =   1
      Style           =   6
      HotTracking     =   -1  'True
      Appearance      =   1
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Clear"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   6360
      Width           =   3975
   End
   Begin VB.ListBox List2 
      Height          =   4935
      Left            =   240
      TabIndex        =   1
      Top             =   1320
      Width           =   3975
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Connect"
      Height          =   735
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   3975
   End
   Begin VB.Menu LineMenu 
      Caption         =   "Line"
      Visible         =   0   'False
      Begin VB.Menu LineMakeCall 
         Caption         =   "MakeCall"
      End
      Begin VB.Menu LineSwapHold 
         Caption         =   "SwapHold"
      End
      Begin VB.Menu LineGetActiveCall 
         Caption         =   "Get Active Call"
      End
      Begin VB.Menu LineMergeCalls 
         Caption         =   "Merge Calls"
      End
      Begin VB.Menu LineSendMessage 
         Caption         =   "Send Message"
      End
   End
   Begin VB.Menu CallMenu 
      Caption         =   "Call"
      Index           =   1
      Visible         =   0   'False
      Begin VB.Menu CallHangup 
         Caption         =   "Hangup"
         Index           =   1
      End
      Begin VB.Menu CallAnswer 
         Caption         =   "Answer"
         Index           =   2
      End
      Begin VB.Menu CallRedirectTo 
         Caption         =   "RedirectTo"
      End
      Begin VB.Menu CallUnhold 
         Caption         =   "Unhold"
      End
      Begin VB.Menu CallMergeCalls 
         Caption         =   "Merge Calls"
      End
      Begin VB.Menu CallStartCallRecording 
         Caption         =   "Start Call Recording"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim WithEvents App As ENETTSCLib.Application
Attribute App.VB_VarHelpID = -1
Dim CallString As String
   
Private Sub App_OnReconnect()
    List2.AddItem "Connection to TAPI-Server reestablished."
    RefreshList
End Sub

Private Sub App_OnDisconnect()
    List2.AddItem "Lost connection to TAPI-Server !"
    RefreshList
End Sub

Private Sub App_OnCallBusy(ByVal pCall As Object)
    CallString = "Busy Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnCallConferenced(ByVal pCall As Object)
    CallString = "Conferenced Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnCallConnected(ByVal pCall As Object)
    CallString = "Connected Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnCallDestroyed(ByVal pCall As Object)
    CallString = "Destroyed Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RemoveCall pCall
End Sub

Private Sub App_OnCallDialing(ByVal pCall As Object)
    CallString = "Dialing Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnCallDisconnected(ByVal pCall As Object)
    CallString = "Disconnected Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnCallHold(ByVal pCall As Object)
    CallString = "Hold Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnCallOffering(ByVal pCall As Object)
    CallString = "Offering Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnCallRingback(ByVal pCall As Object)
    CallString = "Ringback Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub App_OnNewUserMessage()
    For i = 1 To App.UserMessageCount
        List2.AddItem "User Message: " + App.GetNextUserMessage
    Next i
End Sub

Private Sub App_OnRemotePartyChanged(ByVal pCall As Object)
    CallString = "Remote Party Changed Event"
    List2.AddItem CallString + " on " + pCall.ParentLine.Number
    RefreshOrCreateCall pCall
End Sub

Private Sub CallAnswer_Click(Index As Integer)
    Dim aCall As ENETTSCLib.Call
    Set aCall = LCTree.SelectedItem.Tag
    Call aCall.Answer
End Sub

Private Sub CallHangup_Click(Index As Integer)
    Dim aCall As ENETTSCLib.Call
    Set aCall = LCTree.SelectedItem.Tag
    Call aCall.Hangup
End Sub

Private Sub CallMergeCalls_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub

    Dim aCall As ENETTSCLib.Call
    Set aCall = LCTree.SelectedItem.Tag
    Call aCall.MergeCall
End Sub

Private Sub CallRedirectTo_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub
    
    Dim Number As String
    
    Number = InputBox("Geben Sie die Zielnummer ein:")
    
    Dim aCall As ENETTSCLib.Call
    Set aCall = LCTree.SelectedItem.Tag
    aCall.RedirectTo (Number)
End Sub


Private Sub CallStartCallRecording_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub

    Dim aCall As ENETTSCLib.Call
    Set aCall = LCTree.SelectedItem.Tag
    
On Error GoTo CallStartCallRecordingFehler
    Call aCall.StartCallRecording

    Exit Sub
    
CallStartCallRecordingFehler:
    MsgBox ("Fehler bei der Aufzeichnung ! Error: " + Str(Err.Number) + " (0x" + Hex$(Err.Number) + ")")
    
End Sub

Private Sub CallUnhold_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub

    Dim aCall As ENETTSCLib.Call
    Set aCall = LCTree.SelectedItem.Tag
    
    Call aCall.Unhold
End Sub

Private Sub LineGetActiveCall_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub
       
    Dim aLine As ENETTSCLib.Line
    Set aLine = LCTree.SelectedItem.Tag
    If aLine.ActiveCall Is Nothing Then
        MsgBox ("No Active Call")
    Else
        MsgBox ("Active Call: 0x" + String(8 - Len(Hex(aLine.ActiveCall.ID)), "0") + Hex(aLine.ActiveCall.ID))
    End If
End Sub

Private Sub LineMakeCall_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub
    
    Dim Number As String
    
    Number = InputBox("Geben Sie die Zielnummer ein:")
    
    Dim aLine As ENETTSCLib.Line
    Set aLine = LCTree.SelectedItem.Tag
    
    On Error GoTo VerbindungsFehler
    aLine.MakeCall (Number)
    
    Exit Sub
    
VerbindungsFehler:
    MsgBox ("Fehler in der Verbindung ! Error: " + Str(Err.Number) + " (0x" + Hex$(Err.Number) + ")")
    
End Sub

Private Sub Command1_Click()
    
    List2.Clear
    
    Dim Line As ENETTSCLib.Line
    
    Set App = New ENETTSCLib.Application
    
    'App.SetLogin "stm", ""
    'App.SetServer "localhost", 7202
    
    App.Connect
    
    Set Line = App.FirstLine
    'Set App = Nothing
    'Line.Open
    'Line.MakeCall "253"
       
    'Set App = Line.Application
    
    'Set Line = Nothing
    
    'On Error Resume Next
    
    For Each Line In App.Lines
        Line.Open
    Next
        
    'App.FirstLine.Open
    'App.SecondLine.Open
    'App.FirstLine.MakeCall "131"
    'App.SecondLine.MakeCall "202"
       
    RefreshList
    
    'Command2_Click
end_this_sub:
End Sub

Private Sub RefreshList()
    Dim aLine As ENETTSCLib.Line
    Dim aCall As ENETTSCLib.Call
    Dim LineNode As Node
    Dim CallNode As Node
    Dim StateString As String

    LCTree.Nodes.Clear
    
    For Each aLine In App.Lines
        Set LineNode = LCTree.Nodes.Add(, , "L" + CStr(aLine.ID), "Line (" + aLine.Number + ", 0x" + String(8 - Len(Hex(aLine.ID)), "0") + Hex(aLine.ID) + ")")
        Set LineNode.Tag = aLine
        
        For Each aCall In aLine.Calls
        
            Call RefreshOrCreateCall(aCall)
        
        Next
    Next
       
    CallString = ""
End Sub

Private Sub RefreshOrCreateCall(aCall As ENETTSCLib.Call)
    Dim StateString As String
    
    StateString = ""

    Select Case aCall.State
    Case ENETTSCLib.csBusy
        StateString = "busy"
    Case ENETTSCLib.csConnected
        StateString = "connected"
    Case ENETTSCLib.csDestroyed
        StateString = "destroyed"
    Case ENETTSCLib.csDialing
        StateString = "dialing"
    Case ENETTSCLib.csDisconnected
        StateString = "disconnected"
    Case ENETTSCLib.csHold
        StateString = "hold"
    Case ENETTSCLib.csNull
        StateString = "null"
    Case ENETTSCLib.csOffering
        StateString = "offering"
    Case ENETTSCLib.csRingback
        StateString = "ringback"
    End Select
        
    Dim CallNode As Node
    Dim LineNode As Node
    
On Error GoTo CreateCall
    
    Set CallNode = LCTree.Nodes.Item("C" + CStr(aCall.ID))
    CallNode.Text = "Call (" + StateString + ") -> " + aCall.CurrentNumber + "(" + aCall.DisplayName + ", 0x" + String(8 - Len(Hex(aCall.ID)), "0") + Hex(aCall.ID) + ", 0x" + String(8 - Len(Hex(aCall.ParentLine.ID)), "0") + Hex(aCall.ParentLine.ID) + ")"
    CallNode.EnsureVisible
    
    Exit Sub
    
CreateCall:
    ' Get Line Node
    Set LineNode = LCTree.Nodes.Item("L" + CStr(aCall.ParentLine.ID))
        
    If LineNode Is Nothing Then Exit Sub
        
    Set CallNode = LCTree.Nodes.Add(LineNode, tvwChild, "C" + CStr(aCall.ID), "Call (" + StateString + ") -> " + aCall.CurrentNumber + "(" + aCall.DisplayName + ", 0x" + String(8 - Len(Hex(aCall.ID)), "0") + Hex(aCall.ID) + ", 0x" + String(8 - Len(Hex(aCall.ParentLine.ID)), "0") + Hex(aCall.ParentLine.ID) + ")")
    Set CallNode.Tag = aCall
    CallNode.EnsureVisible
End Sub

Private Sub RemoveCall(aCall As ENETTSCLib.Call)
On Error GoTo RemoveCallExit
    LCTree.Nodes.Remove ("C" + CStr(aCall.ID))
RemoveCallExit:
End Sub

Private Sub Command4_Click()
    List2.Clear
End Sub

Private Sub Form_Terminate()
    If (Not (App Is Nothing)) Then
        ' App.Dispose
        Set App = Nothing
    End If
End Sub

Private Sub LCTree_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    If LCTree.SelectedItem Is Nothing Then Exit Sub
    
    If Button = vbRightButton Then
    
        If Left(LCTree.SelectedItem.Key, 1) = "L" Then
            PopupMenu LineMenu
        Else
            PopupMenu CallMenu(1)
        End If
    
    End If

End Sub

Private Sub LineMergeCalls_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub
    
    Dim aLine As ENETTSCLib.Line
    Set aLine = LCTree.SelectedItem.Tag
    Call aLine.MergeCalls
End Sub

Private Sub LineSendMessage_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub
    
    Dim sMessage As String
    
    sMessage = InputBox("Geben Sie die Nachricht ein:")
    
    Dim aLine As ENETTSCLib.Line
    Set aLine = LCTree.SelectedItem.Tag
    aLine.SendMessage (sMessage)
End Sub

Private Sub LineSwapHold_Click()
    If LCTree.SelectedItem Is Nothing Then Exit Sub
    
    Dim aLine As ENETTSCLib.Line
    Set aLine = LCTree.SelectedItem.Tag
    Call aLine.SwapHold
End Sub
