// FindContacts.h : Declaration of the CFindContacts

#pragma once
#include "resource.h"       // main symbols
#include "EProCallExt.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

// CFindContacts
class ATL_NO_VTABLE CFindContacts :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CFindContacts, &CLSID_FindContacts >
	, public IDispatchImpl < ECtiClientLib::IFindContacts, &__uuidof(ECtiClientLib::IFindContacts), &__uuidof(ECtiClientLib::__ECtiClientLib) >
{
public:
	HRESULT FinalConstruct();
	void FinalRelease();

	DECLARE_REGISTRY_RESOURCEID(IDR_FINDCONTACTS)

	BEGIN_COM_MAP(CFindContacts)
		COM_INTERFACE_ENTRY(ECtiClientLib::IFindContacts)
		COM_INTERFACE_ENTRY(IDispatch)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

public:
	STDMETHOD (raw_OnFindContacts) (/*[in]*/ IDispatch* pFindOptions, /*[in]*/ IDispatch* pContactOSP);
};

OBJECT_ENTRY_AUTO(__uuidof(FindContacts), CFindContacts)
