VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "ENetSN VB6 Demo"
   ClientHeight    =   3990
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7185
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   7185
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List1 
      Height          =   2010
      Left            =   240
      TabIndex        =   9
      Top             =   360
      Width           =   6735
   End
   Begin VB.CommandButton cmdDrop 
      Caption         =   "Drop"
      Height          =   285
      Left            =   3840
      TabIndex        =   5
      Top             =   3120
      Width           =   1095
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Dial !"
      Height          =   285
      Left            =   2640
      TabIndex        =   4
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox Text2 
      Height          =   285
      Left            =   1560
      TabIndex        =   3
      Top             =   3120
      Width           =   975
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   480
      TabIndex        =   2
      Top             =   3120
      Width           =   975
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Disconnect"
      Height          =   495
      Left            =   5400
      TabIndex        =   1
      Top             =   3240
      Width           =   1575
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Connect"
      Height          =   495
      Left            =   5400
      TabIndex        =   0
      Top             =   2640
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Appearance      =   0  'Flat
      Caption         =   "Dial"
      ForeColor       =   &H80000008&
      Height          =   1215
      Left            =   240
      TabIndex        =   6
      Top             =   2520
      Width           =   4935
      Begin VB.Label Label2 
         Caption         =   "To"
         Height          =   255
         Left            =   1320
         TabIndex        =   8
         Top             =   360
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "From"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   7
         Top             =   360
         Width           =   615
      End
   End
   Begin VB.Label Label3 
      Caption         =   "Incoming Calls and Events:"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim WithEvents App As ENETSNLib.Application
Attribute App.VB_VarHelpID = -1

' correct type information is a major change between this and the prior version.
' you should change your application to use TypLib3.0 regardless which object
' implementaion/version is really used.
Private Sub App_OnCNCallOffering(ByVal pCallInformation As Object)
    ' the following "dynamic cast" from Object to ENETSNLib.CallInformation is not needed
    ' it demonstrates only that the object behind is really type save
    Dim tCall As ENETSNLib.CallInformation
    Set tCall = pCallInformation
    List1.AddItem ("Incoming Call from: " + tCall.RemoteContact.CurrentNumberSC + _
        " (" + tCall.DisplayName + ") to: " + tCall.LocalNumber + _
        " (" + tCall.DisplayName + ")")

End Sub

Private Sub App_OnDisconnect()
    List1.AddItem ("Connection to Server lost !")
End Sub

Private Sub App_OnReconnect()
    List1.AddItem ("Server reconnected.")
End Sub

Private Sub cmdDrop_Click()
   On Error GoTo c3c_errhandler
    App.DropCall Text1.Text
    GoTo c3c_exit
    
c3c_errhandler:
    MsgBox Err.Description
    
c3c_exit:

End Sub

Private Sub Command1_Click()
    On Error GoTo c1c_errhandler
    
    ' choose your implementaion using version independend ProID
    Set App = CreateObject("ENetSN.Application")
    
    ' choose your implementaion explizit by specifying ProgID
    ' Set App = CreateObject("ENetSN.Application.1")
    ' App.SetServer "localhost", 7202
    
    ' Set App = CreateObject("ENetSN.Application.3")
    ' App.SetServer "localhost", 7222
    
    App.Connect coFirstAndSecondLine
    
    List1.AddItem ("Server connected.")
    List1.AddItem ("First Line: " + App.FirstLine)
    List1.AddItem ("Second Line: " + App.SecondLine)
    Text1.Text = App.FirstLine
    GoTo c1c_exit
    
c1c_errhandler:
    MsgBox Err.Description
    
c1c_exit:

End Sub

Private Sub Command2_Click()
    Set App = Nothing
    List1.AddItem ("TAPI-Server connection closed.")
    Text1.Text = ""
    Text2.Text = ""
End Sub

Private Sub Command3_Click()
    On Error GoTo c3c_errhandler
    App.MakeCall Text1.Text, Text2.Text
        
    GoTo c3c_exit
    
c3c_errhandler:
    MsgBox Err.Description
    
c3c_exit:

End Sub

